import React from 'react'
export declare type ModuleComponent<P = any> = {
  [property: string]: React.FunctionComponent<P> | React.ClassType<P, any, any>
}
export declare type ModuleComponentInterop<P> =
  | Promise<ModuleComponent<P>>
  | ModuleComponent<P>
export declare type AsyncComponentGetter<P> = () => ModuleComponentInterop<P>
export interface AsyncComponentOptions<P> {
  property?: string
  loading?: (props: P) => React.ReactNode | React.ReactNode[]
  error?: (exception: any, props: P) => React.ReactNode | React.ReactNode[]
}
declare type AsyncComponentType<P> = React.FC<P> & {
  load: AsyncComponentGetter<P>
}
declare function createAsyncComponent<P>(
  componentGetter: AsyncComponentGetter<P>,
  options?: AsyncComponentOptions<P>
): AsyncComponentType<P>
export default createAsyncComponent
